unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls
  ,fpreport
  ,dbf
  ,fpreportdb
  ,fpttf
  ,fpreportpdfexport
  ,fpReportStreamer
  ,fpjson
  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private

  public
    procedure LoadReportDesign(aReport :TFPCustomReport; aFileFprPath: string);

  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  _rpt: TFPCustomReport;
  _masterDataSet: TDBF;
  _MasterData: TFPReportDatasetData;
  _detailDataSet: TDBF;
  _DetailData: TFPReportDatasetData;
  _rptExporter: TFPReportExporter;

begin
  _rptExporter := nil;

  {$REGION 'CheckFile'}
  if not FileExists('data\master.dbf') then
  begin
    writeln('Unable to find database file <master.dbf>!');
    writeln('');
    exit;
  end;

  if not FileExists('data\detail.dbf') then
  begin
    writeln('Unable to find database file <detail.dbf>!');
    writeln('');
    exit;
  end;
  {$ENDREGION}

  // ***** Providing data to the report *****
  _MasterData := TFPReportDatasetData.Create(nil);
  _MasterData.Name:='Master';
  _masterDataSet := TDBF.Create(nil);
  _masterDataSet.TableName := 'data\master.dbf';
  _masterDataSet.Name:='Master';
  _MasterData.DataSet := _masterDataSet;


  _DetailData := TFPReportDatasetData.Create(nil);
  _DetailData.Name:='Detail';
  _detailDataSet := TDBF.Create(nil);
  _detailDataSet.TableName := 'data\detail.dbf';
  _detailDataSet.Name:='Detail';
  _DetailData.DataSet := _detailDataSet;

  _rpt := TFPCustomReport.Create(self);
  self.LoadReportDesign(_rpt, 'data\test_05.json');

  TFPReportGroupHeaderBand(_rpt.FindRecursive('GroupHeaderBandMaster')).Data := _MasterData;

  TFPReportDataBand(_rpt.FindRecursive('DataHeaderBand1')).Data := _MasterData;
  TFPReportDataBand(_rpt.FindRecursive('MasterDataBand')).Data := _MasterData;

  TFPReportGroupFooterBand(_rpt.FindRecursive('GroupHeaderBandDetail')).Data := _DetailData;

  TFPReportDataBand(_rpt.FindRecursive('DetailDataBand')).Data := _DetailData;
  TFPReportDataBand(_rpt.FindRecursive('DetailDataBand')).MasterBand := TFPReportDataBand(_rpt.FindRecursive('MasterDataBand'));

  TFPReportGroupFooterBand(_rpt.FindRecursive('GroupFooterBandDetail')).Data := _DetailData;


  TFPReportGroupFooterBand(_rpt.FindRecursive('GroupFooterBandMaster')).Data := _MasterData;
  try
    // ***** Running the report *****
    gTTFontCache.SearchPath.Add('fonts\');
    gTTFontCache.BuildFontCache;
    _rpt.RunReport;

    // ***** Rendering (or exporting) the report *****
    if Assigned(_rptExporter) then
      FreeAndNil(_rptExporter);

    _rptExporter := TFPReportExportPDF.Create(nil);
    _rpt.RenderReport(_rptExporter);

    ShowMessage('File created.');

  finally
    // Freeing all objects we used
    FreeAndNil(_rptExporter);
    FreeAndNil(_rpt);
    FreeAndNil(_MasterData);
    FreeAndNil(_masterDataSet);
    FreeAndNil(_DetailData);
    FreeAndNil(_detailDataSet);
  end;
end;


procedure TForm1.LoadReportDesign(aReport: TFPCustomReport; aFileFprPath: string);
Var
  J : TFPReportJSONStreamer;
  F : TFileStream;
  O : TJSONObject;

begin
  J:=Nil;
  F:=TFileStream.Create(aFileFprPath,fmOpenRead);
  try
    O:=GetJSON(F) as TJSONObject;
    J:=TFPReportJSONStreamer.Create(Self);
    J.JSON:=O;
    J.OwnsJSON:=True;
    aReport.ReadElement(j);
  finally
    F.Free;
    J.Free;
  end;
end;

end.

